summaryrefslogtreecommitdiffstats
path: root/patches/source/btrfs-progs
diff options
context:
space:
mode:
Diffstat (limited to 'patches/source/btrfs-progs')
-rwxr-xr-xpatches/source/btrfs-progs/btrfs-progs.SlackBuild127
-rw-r--r--patches/source/btrfs-progs/slack-desc19
2 files changed, 146 insertions, 0 deletions
diff --git a/patches/source/btrfs-progs/btrfs-progs.SlackBuild b/patches/source/btrfs-progs/btrfs-progs.SlackBuild
new file mode 100755
index 000000000..f02b75a0f
--- /dev/null
+++ b/patches/source/btrfs-progs/btrfs-progs.SlackBuild
@@ -0,0 +1,127 @@
+#!/bin/sh
+# Copyright 2009, 2010, 2011 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+CWD=$(pwd)
+
+PKGNAM=btrfs-progs
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+# Download the btrfs-progs Git head if there's no tarball:
+if ! /bin/ls $CWD/btrfs-progs*tar* 1> /dev/null 2> /dev/null ; then
+ git clone git://git.kernel.org/pub/scm/linux/kernel/git/mason/btrfs-progs.git
+ rm -r btrfs-progs/.git
+ tar cf btrfs-progs-$(date +%Y%m%d).tar btrfs-progs
+ xz -9 btrfs-progs-$(date +%Y%m%d).tar
+ rm -r $CWD/btrfs-progs
+fi
+
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.xz | cut -f 3 -d - | cut -f 1 -d .)}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ "$TMP" = "" ]; then
+ TMP=/tmp
+fi
+PKG=$TMP/package-${PKGNAM}
+rm -rf $PKG
+mkdir -p $PKG
+
+cd $TMP
+rm -rf btrfs-progs
+tar xf $CWD/$PKGNAM-$VERSION.tar.xz || exit 1
+cd btrfs-progs
+
+# Make sure ownerships and permissions are sane:
+chown -R root:root .
+find . -perm 666 -exec chmod 644 {} \;
+find . -perm 664 -exec chmod 644 {} \;
+find . -perm 600 -exec chmod 644 {} \;
+find . -perm 444 -exec chmod 644 {} \;
+find . -perm 400 -exec chmod 644 {} \;
+find . -perm 440 -exec chmod 644 {} \;
+find . -perm 777 -exec chmod 755 {} \;
+find . -perm 775 -exec chmod 755 {} \;
+find . -perm 511 -exec chmod 755 {} \;
+find . -perm 711 -exec chmod 755 {} \;
+find . -perm 555 -exec chmod 755 {} \;
+
+# Build:
+make prefix=/usr bindir=/sbin $NUMJOBS || make prefix=/usr bindir=/sbin || exit 1
+
+# Install:
+make install prefix=/usr bindir=/sbin DESTDIR=$PKG || exit 1
+
+# Strip binaries:
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+# Move manpages:
+mv $PKG/usr/share/man $PKG/usr/man
+rmdir $PKG/share
+
+# Do not ship libraries.
+# If there becomes a use for these outside of btrfs-progs, let me know.
+rm -rf $PKG/usr/lib
+
+# According to https://btrfs.wiki.kernel.org/index.php/FAQ#When_will_Btrfs_have_a_fsck_like_tool.3F
+# it is not recommended to make fsck.btrfs a no-op by linking it to /bin/true:
+ln -sf /bin/true $PKG/sbin/fsck.btrfs
+
+# Compress and link manpages, if any:
+if [ -d $PKG/usr/man ]; then
+ ( cd $PKG/usr/man
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.?
+ )
+ done
+ )
+fi
+
+# Add a documentation directory:
+mkdir -p $PKG/usr/doc/${PKGNAM}-$VERSION
+cp -a \
+ COPYING* INSTALL README* \
+ $PKG/usr/doc/${PKGNAM}-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $TMP/package-${PKGNAM}
+makepkg -l y -c n ../${PKGNAM}-$VERSION-$ARCH-$BUILD.txz
+
diff --git a/patches/source/btrfs-progs/slack-desc b/patches/source/btrfs-progs/slack-desc
new file mode 100644
index 000000000..d53953c80
--- /dev/null
+++ b/patches/source/btrfs-progs/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler-------------------------------------------------------|
+btrfs-progs: btrfs-progs (Btrfs filesystem utilities)
+btrfs-progs:
+btrfs-progs: Btrfs is a new copy on write filesystem for Linux aimed at implementing
+btrfs-progs: advanced features while focusing on fault tolerance, repair and easy
+btrfs-progs: administration. Initially developed by Oracle, Btrfs is licensed under
+btrfs-progs: the GPL and open for contribution from anyone.
+btrfs-progs:
+btrfs-progs:
+btrfs-progs:
+btrfs-progs: Btrfs homepage: http://btrfs.wiki.kernel.org
+btrfs-progs: